!===============================================
! dotprod.f90

! calculate dot product and write result to
! an unformatted file, read result to check
! code
!===============================================
program dotprod

  !-------------------------------------------
  ! module containing precision parameter
  !-------------------------------------------
  use prec_mod,  only: rk

  !-------------------------------------------
  ! module containing derived type
  !-------------------------------------------
  use rvec3_mod, only: rvec3

  implicit none
  integer :: i
  real(rk) :: c, qc
  type(rvec3) :: a, b

  !-------------------------------------------
  ! set nvals for each vector
  !-------------------------------------------
  a%nvals = 3
  b%nvals = 3

  !----------------------------
  ! input vectors
  !----------------------------
  print*,'Enter first vector'
  read*, a%x
  print*,'Enter second vector'
  read*, b%x

  !----------------------------
  ! calculate dot product
  !----------------------------
  call dp(a%x, b%x, c)

  !----------------------------
  ! check magnitude
  !----------------------------
  if(abs(c) < 1.0e-6) then
     print*,'---------------------------------------------------'
     print*,'Warning: magnitude of dot product is less than 1e-6'
     print*,'---------------------------------------------------'
  endif

  !----------------------------
  ! write result to file
  !----------------------------
  open(21, file = 'dot.d', form = 'unformatted')
  write(21) c
  close(21)
  print*,' '
  print*,'Output written to file dot.d'


  !----------------------------
  ! read result from file and
  ! print value
  !----------------------------
  open(21, file='dot.d', form = 'unformatted')
  read(21) c
  print*,' '
  print*,'Value read from file = ', c

end program dotprod
