!===============================================
! dotprod.f90
! prompt for two real vectors of length 3,
! calculate dot product in subroutine
!===============================================
subroutine dp(x,y,d)
  implicit none
  real :: d
  real, dimension(3) :: x, y
  d = sum(x*y)
end subroutine dp

program dotprod
  implicit none
  integer :: i
  real :: c
  real, dimension(3) :: a, b

  !----------------------------
  ! input vectors
  !----------------------------
  print*,'Enter first vector'
  read*, a
  print*,'Enter second vector'
  read*, b

  !----------------------------
  ! calculate dot product
  !----------------------------
  call dp(a,b,c)

  !----------------------------
  ! check magnitude
  !----------------------------
  if(abs(c) < 1.0e-6) then
     print*,'---------------------------------------------------'
     print*,'Warning: magnitude of dot product is less than 1e-6'
     print*,'---------------------------------------------------'
  endif

  !----------------------------
  ! print result
  !----------------------------
  print*,'dot product = ', c

end program dotprod
